unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, MMSystem;

type
  TForm1 = class(TForm)
    Imp: TImage;
    Bt1: TImage;
    Bt2: TImage;
    Bt3: TImage;
    btFim: TImage;
    btMin: TImage;
    Bt4: TImage;
    Bt5: TImage;
    Bt2Up: TImage;
    Bt2Dw: TImage;
    Bt1Dw: TImage;
    Bt1Up: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    procedure Bt1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Bt1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure ImpMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ImpMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ImpMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure btFimMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure btFimMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure btMinMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure btMinMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    procedure TransCriar;
  end;

var
  Form1: TForm1;

implementation
{$R *.DFM}

var
  Lx,Ly: integer;
  Lk: byte;

procedure TForm1.FormCreate(Sender: TObject);
begin
  TransCriar;
end;


//=== Encerrar o jogo ==========================================================
procedure TForm1.btFimMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  btFim.Picture.Assign(Bt2Dw.Picture);
  PlaySound('clic1.wav',SND_ASYNC,0);
end;

procedure TForm1.btFimMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  btFim.Picture.Assign(Bt2Up.Picture);
  PlaySound('clic2.wav',SND_ASYNC,0);
  Application.Terminate;
end;


//=== Minimizar o formulrio ===================================================
procedure TForm1.btMinMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  btMin.Picture.Assign(Bt2Dw.Picture);
  PlaySound('clic1.wav',SND_ASYNC,0);
end;

procedure TForm1.btMinMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  btMin.Picture.Assign(Bt2Up.Picture);
  PlaySound('clic2.wav',SND_ASYNC,0);
  Application.Minimize;
end;


//=== Cria o formulrio transparente ===========================================
procedure TForm1.TransCriar;
var
  MaskMap: TBitmap;
  LinRgn,SpRgn,WinRgn: HRGN;
  Lin,Col,Cor: integer;
  Sl: PByteArray;
  SpEsq,SpDir: integer;
begin
  BorderStyle:= bsNone;
  BorderIcons:= [];
  MaskMap:= TBitmap.Create;
  MaskMap.Width:= Imp.Width;
  MaskMap.Height:= Imp.Height;
  MaskMap.Assign(Imp.Picture.Bitmap);
  MaskMap.Mask(clFuchsia);
  MaskMap.Canvas.CopyMode:= cmDSTINVERT;
  MaskMap.Canvas.Draw(0,0,MaskMap);
  MaskMap.PixelFormat:= pf8Bit;
  MaskMap.Canvas.CopyMode:= cmSRCCOPY;
  Height:= Imp.Height;
  Width:= Imp.width;
  WinRgn:= CreateRectRgn(0,0,0,0);
  for Lin:= 0 to Height-1 do begin
    LinRgn:= CreateRectRgn(0,Lin,0,Lin);
    Sl:= MaskMap.scanline[Lin];
    SpEsq:= 0;// SpDir:= 0;
    repeat
      Col:= SpEsq;
      Cor:= Sl[Col];
      repeat
        Col:= Col + 1;
      until (Cor <> Sl[Col]) or (Col >= Width);
      SpDir:= Col - 1;
      if Cor <> 0 then begin
        SpRgn:= CreateRectRgn(SpEsq,Lin,SpDir+1,Lin+1);
        CombineRgn(LinRgn, LinRgn, SpRgn, RGN_OR);
        DeleteObject(SpRgn);
      end;
      SpEsq:= SpDir+1;
    until (SpDir >= Width);
    CombineRgn(WinRgn, WinRgn, LinRgn, RGN_OR);
    DeleteObject(LinRgn);
  end;
  SetWindowRgn(Handle,WinRgn,True);
  MaskMap.Free;
end;


//=== Movimento do form pela tela ==============================================
procedure TForm1.ImpMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Lx:= X; Ly:= Y; Lk:= 1;
end;

procedure TForm1.ImpMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if Lk = 1 then begin
    if X > Lx then Left:= Left + (X - Lx);
    if X < Lx then Left:= Left - (Lx - X);
    if Y > Ly then Top:= Top + (Y - Ly);
    if Y < Ly then Top:= Top - (Ly - Y);
  end;
end;

procedure TForm1.ImpMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Lk:= 0;
end;



////////////////////////////////////////////////////////////////////////////////
procedure TForm1.Bt1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if sender = Bt1 then Bt1.Picture.Assign(Bt1Dw.Picture);
  if sender = Bt2 then Bt2.Picture.Assign(Bt1Dw.Picture);
  if sender = Bt3 then Bt3.Picture.Assign(Bt1Dw.Picture);
  if sender = Bt4 then Bt4.Picture.Assign(Bt2Dw.Picture);
  if sender = Bt5 then Bt5.Picture.Assign(Bt2Dw.Picture);
  PlaySound('clic1.wav',SND_ASYNC,0);
end;

procedure TForm1.Bt1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if sender = Bt1 then Bt1.Picture.Assign(Bt1Up.Picture);
  if sender = Bt2 then Bt2.Picture.Assign(Bt1Up.Picture);
  if sender = Bt3 then Bt3.Picture.Assign(Bt1Up.Picture);
  if sender = Bt4 then Bt4.Picture.Assign(Bt2Up.Picture);
  if sender = Bt5 then Bt5.Picture.Assign(Bt2Up.Picture);
  PlaySound('clic2.wav',SND_ASYNC,0);  
end;




end.
